#ifndef _HG_DATUM_H_
#define _HG_DATUM_H_

#include <string>

namespace HG //Beginn des Namensraumes
{

//==============================================================
// Klasse Datum
//==============================================================
class Datum
{
  //------------------------------------------------------------
  // Constructoren
  //------------------------------------------------------------
  public:
     Datum (void);            // Standardconstructor
     Datum (Datum &pDatum);   // Copy-Constructor
     Datum (Datum *ptrDatum); // Copy-Constructor
     Datum (int pTag, int pMonat, int pJahr);

  //------------------------------------------------------------
  // Methoden 
  //------------------------------------------------------------
  public:
    void        set                (int pTag, int pMonat, int pJahr);
    long        getLong            (void);
    long        getLongSortierbar  (void);
    std::string getString          (void);
    void        setHeute           (void);
    bool        isSchaltjahr       (int pJahr);

  //------------------------------------------------------------
  // Methoden: Getter und Setter 
  //------------------------------------------------------------
  public:
    int  getTag   (void);
    void setTag   (int pTag);
    int  getMonat (void);
    void setMonat (int pMonat);
    int  getJahr  (void);
    void setJahr  (int pJahr);

  //------------------------------------------------------------
  // Methoden, intern
  //------------------------------------------------------------
  private:
    void correct (void);

  //------------------------------------------------------------
  // Member
  //------------------------------------------------------------
  private:
    int nTag;
    int nMonat;
    int nJahr;

    bool bDirty;
};

} // Ende des Namensraumes
#endif